<script lang="ts" setup>
import { enumPageComponentTemplate, enumPageComponentKey, enumPageComponentLayouts } from "@/definitions/enum";
import { Article_Collection, Category_Collection } from "./index";

const _props = defineProps<{
  settings: any;
  component?: any;
  content?: any;
}>();
const definedDynamicComponent: Record<string, any> = {
  [enumPageComponentTemplate[enumPageComponentKey.COLLECTION]["ARTICLE"]]: Article_Collection,
  [enumPageComponentTemplate[enumPageComponentKey.COLLECTION]["CATEGORY"]]: Category_Collection,
};

const getCurrentComponent = computed(() => _props.settings.template);
const GET_PROPS = computed(() => {
  return () => {
    let props: any = {};
    if (_props.settings) {
      for (const [key, value] of Object.entries(_props.settings)) {
        props = {
          ...props,
          [key]: value,
        };
      }
      return props;
    }
  };
});

</script>

<template>
  <component 
    v-if="definedDynamicComponent[getCurrentComponent]"
    :is="definedDynamicComponent[getCurrentComponent]" 
    v-bind="{ ...GET_PROPS(), component: _props.component, settings: _props.settings, content: _props.content }" 
  />
</template>
